from object import Object
import os

class Enemy(Object):
    
    enemy = None
    killsound = None
    
    def __init__(self, target, x, y):
        if Enemy.enemy is None:
            import pygame
            Enemy.enemy = pygame.image.load(os.path.join("image", "enemy.png"))
            Enemy.killsound = pygame.mixer.Sound(os.path.join("sound", "kill.wav"))
            Enemy.killsound.set_volume(0.1)
            
        super(Enemy, self).__init__(x, y, Enemy.enemy)
        self.target = target
        self.speed = 0.5
        self.jump = 0.0
        self.health = 3
        self.cooldown = 0.0
        
    def update(self):
        super(Enemy, self).update()
        
        self.cooldown = max(0, self.cooldown - 0.1)
        self.jump += 0.5
        
        from main import Main
        import math
        
        center = [self.x + self.image.get_width() / 2.0, self.y + self.image.get_height() / 2.0]
        
        for object in Main.buildings:
            tocenter = [object.x + object.image.get_width() / 2.0, object.y + object.image.get_height() / 2.0]
            to = [center[0] - tocenter[0], center[1] - tocenter[1]]
            len = math.sqrt(to[0] * to[0] + to[1] * to[1])
            if len < 16:
                if self.cooldown == 0.0:
                    object.damage()
                    self.cooldown = 3.0
                return
        
        tocenter = [self.target.x + self.target.image.get_width() / 2.0, self.target.y + self.target.image.get_height() / 2.0]
        to = [tocenter[0] - center[0], tocenter[1] - center[1]]
        len = math.sqrt(to[0] * to[0] + to[1] * to[1])
        self.velocity[0] += to[0] / len * self.speed
        self.velocity[1] += to[1] / len * self.speed
        
        if len < 16:
            self.kill()
            self.target.damage()
    
    def damage(self):
        self.health -= 1
        if self.health == 0:
            self.kill()
        
    def kill(self):
        from main import Main
        Main.addBlood(self.x, self.y)
        self.ondestroy = True
        
    def draw(self, window):
        import math
        window.blit(self.image, (self.x, self.y + math.sin(self.jump) * 3))