class Explosion(object):
    
    def __init__(self, x, y, amount = 48, live = 25):
        self.x = x
        self.y = y
        self.particles = []
        self.ondestroy = False
        self.time = 0
        self.live = live
        self.amount = amount
        
        self.initParticles()
        
    def initParticles(self):
        import math, random, pygame
        for i in range(0, self.amount):
            an = random.random() * math.pi * 2
            vx = math.cos(an)
            vy = math.sin(an)
            speed = 4 + random.random()
            color = pygame.Color(255, 150 + int(random.random() * 100), 0)
            self.particles.append([self.x, self.y, vx * speed, vy * speed, color])
        
    def draw(self, window):
        import pygame
        from main import Main
        
        pix = pygame.PixelArray(window)
        for particle in self.particles:
            if particle[0] > 0 and particle[0] < Main.size[0] and \
               particle[1] > 0 and particle[1] < Main.size[1]:
                
                pix[int(particle[0])][int(particle[1])] = particle[4]
        del pix
            
    def update(self):
        self.time += 1
        if self.time > self.live:
            self.ondestroy = True
        for particle in self.particles:
            particle[0] += particle[2]
            particle[1] += particle[3]