from object import Object
import math, os

class Missile(Object):
    missile = None
    hit = None
    
    def __init__(self, x, y, tx, ty):
        if Missile.missile is None:
            import pygame
            Missile.missile = pygame.image.load(os.path.join("image", "missile.png"))
            Missile.hit = pygame.mixer.Sound(os.path.join("sound", "hit.wav"))
        
        super(Missile, self).__init__(x, y, Missile.missile)
        
        to = [tx - x, ty - y]
        len = math.sqrt(to[0] * to[0] + to[1] * to[1])
        
        self.passed = 0
        
        if len != 0:
            self.nx = to[0] / len
            self.ny = to[1] / len
        else:
            self.nx = 1
            self.ny = 0
        
    def update(self):
        self.passed += 1
        
        if self.passed > 30:
            self.ondestroy = True
            return
        
        from main import Main
        from enemy import Enemy
        from explosion import Explosion
        
        if self.x < 0 or self.y < 0 or self.x > Main.size[0] or self.y > Main.size[1]:
            ondestroy = True
            return
        
        for object in Main.objects:
            if not isinstance(object, Enemy):
                continue
            to = [object.x - self.x, object.y - self.y]
            len = math.sqrt(to[0] * to[0] + to[1] * to[1])
            if len < self.speed * 2:
                Main.objects.append(Explosion(self.x, self.y))
                object.damage()
                if object.ondestroy:
                    Main.gold += 1
                    Enemy.killsound.play()
                self.ondestroy = True
                Missile.hit.play()
                break
        
        self.x += self.nx * self.speed
        self.y += self.ny * self.speed