from object import Object
import os

class Platform(Object):
    
    platform = None
    platformActive = None
    pickup = None
        
    def __init__(self, x, y):
        if Platform.platform is None:
            import pygame
            Platform.platform = pygame.image.load(os.path.join("image", "platform.png"))
            Platform.platformActive = pygame.image.load(os.path.join("image", "platform-active.png"))
            Platform.pickup = pygame.mixer.Sound(os.path.join("sound", "hp.wav"))
            Platform.pickup.set_volume(0.6)
        
        super(Platform, self).__init__(x, y, Platform.platform)
        
        self.cooldown = 100.0
        self.health = 4.0
        
    def damage(self):
        self.health -= 1.0
        if self.health <= 0:
            self.ondestroy = True
            
            from main import Main
            from explosion import Explosion
            Main.objects.append(Explosion(self.x, self.y, 100))
            
    def update(self):
        self.cooldown = max(0, self.cooldown - 0.1)
        
        if self.cooldown > 0:
            return
            
        from main import Main
        import math
        
        tocenter = [Main.hero.x + Main.hero.image.get_width() / 2.0, Main.hero.y + Main.hero.image.get_height() / 2.0]
        center = [self.x + self.image.get_width() / 2.0, self.y + self.image.get_height() / 2.0]
        to = [tocenter[0] - center[0], tocenter[1] - center[1]]
        length = math.sqrt(to[0] * to[0] + to[1] * to[1])
        
        if length < 32:
            Main.hero.heal()
            self.cooldown = 100.0
            Platform.pickup.play()
                
    def draw(self, window):
        if self.cooldown > 0:
            window.blit(Platform.platform, (self.x, self.y))
        else:
            window.blit(Platform.platformActive, (self.x, self.y))
        