from object import Object
import os

class Tower(Object):
    
    tower = None
    boom = []
    shot = None
        
    def __init__(self, x, y):
        if Tower.tower is None:
            import pygame
            Tower.tower = pygame.image.load(os.path.join("image", "tower-base.png"))
            Tower.shot = pygame.mixer.Sound(os.path.join("sound", "shot.wav"))
            Tower.shot.set_volume(0.15)
            for i in range(0, 1):
                Tower.boom.append(pygame.mixer.Sound(os.path.join("sound", "boom" + str(i) + ".wav")))
        
        super(Tower, self).__init__(x, y, Tower.tower)
        
        self.cooldown = 0.0
        self.radius = 200
        self.target = None
        self.health = 30.0
        
    def damage(self):
        self.health -= 5.0
        if self.health <= 0:
            self.ondestroy = True
            
            from main import Main
            from explosion import Explosion
            import random
            Main.objects.append(Explosion(self.x, self.y, 100))
            Tower.boom[random.randrange(0, 1)].play()
            
        
    def shoot(self):
        self.cooldown = 1.6
        
        from main import Main
        from missile import Missile
        
        center = [self.x + self.image.get_width() / 2.0, self.y + self.image.get_height() / 2.0]
        new = Missile(center[0], center[1], self.target.x, self.target.y)
        new.speed = 10
        
        Main.objects.append(new)
        Tower.shot.play()
        
    def update(self):
        self.cooldown = max(0, self.cooldown - 0.1)
        
        from main import Main
        from enemy import Enemy
        import math
        
        if self.target == None:
            enemies = []
            for object in Main.objects:
                if not isinstance(object, Enemy):
                    continue
                to = [object.x - self.x, object.y - self.y]
                length = math.sqrt(to[0] * to[0] + to[1] * to[1])
                enemies.append((object, length))
            
            enemies = sorted(enemies, key = lambda enemy: enemy[1])
            
            if len(enemies) > 0:
                self.target = enemies[0][0]
        else:
            if self.target.ondestroy:
                self.target = None
                self.update()
                return
            if self.cooldown == 0:
                self.shoot()
                
    def draw(self, window):
        super(Tower, self).draw(window)
        import pygame, math
        center = (self.x + self.image.get_width() / 2.0, self.y + self.image.get_height() / 2.0)
        
        to = [-self.health, 0]
        
        if self.target != None:
            to = [self.target.x - center[0], self.target.y - center[1]]
            len = math.sqrt(to[0] * to[0] + to[1] * to[1])
            to[0] = to[0] / len * self.health
            to[1] = to[1] / len * self.health
        
        pygame.draw.line(window, pygame.Color(128, 0, 0), center, (int(center[0] + to[0]), int(center[1] + to[1])), 2)